package net.jaekl.cfb.analyze;

// Copyright (C) 2015 Christian Jaekl

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;

import net.jaekl.cfb.xml.BugCollection;
import net.jaekl.qd.xml.ParseErrorHandler;
import net.jaekl.qd.xml.ParseHandler;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

public class Analysis {
	BugCollection m_bugCollection;
	String m_buildNumber;
	Date m_date;	// Date/time when analysis was started
	
	public Analysis(String buildNumber) {
		m_bugCollection = null;
		m_buildNumber = buildNumber;
		m_date = new Date();
	}
	
	public BugCollection getBugCollection() { return m_bugCollection; }
	
	public void parse(InputSource xml) throws FileNotFoundException, IOException, SAXException 
	{
		m_bugCollection = new BugCollection();
		
	    XMLReader reader = XMLReaderFactory.createXMLReader();
	    ParseHandler ph = new ParseHandler(m_bugCollection);
	    ParseErrorHandler peh = new ParseErrorHandler();
	    reader.setContentHandler(ph);
	    reader.setErrorHandler(peh);
	    reader.parse(xml);
	}
	
	public void dump(PrintWriter pw)
	{
		if (null != m_bugCollection) {
			m_bugCollection.dump(pw, 2);
		}
	}
}
