package net.jaekl.cfb.xml;

import java.io.PrintWriter;

import net.jaekl.qd.xml.MissingAttributeException;
import net.jaekl.qd.xml.ParseResult;
import net.jaekl.qd.xml.XmlParseException;

import org.xml.sax.Attributes;

public class SourceLine extends ParseResult {

	static final String TAG = "SourceLine";
	static final String[] INTERNAL = { };
	static final Object[][] EXTERNAL = { };
	
	static final String ATTR_CLASS_NAME = "classname";
	static final String ATTR_START = "start";
	static final String ATTR_END = "end";
	
	String m_className;
	int m_start;
	int m_end;

	public SourceLine() {
		super(TAG, INTERNAL, EXTERNAL);
		m_className = null;
		m_start = m_end = (-1);
	}	
	
	@Override
	public void handleMainAttributes(Attributes attr) throws MissingAttributeException {
		String scratch;
		
		m_className = getRequiredAttr(TAG, attr, ATTR_CLASS_NAME);
		
		scratch = getOptionalAttr(attr, ATTR_START, "-1");
		m_start = Integer.parseInt(scratch);
		
		scratch = getOptionalAttr(attr, ATTR_END, "-1");
		m_end = Integer.parseInt(scratch);
	}
	
	@Override
	public void endContents(String uri, String localName, String qName,	String chars) 
		throws XmlParseException 
	{
		// no-op
	}
	
	@Override
	public void endExternal(String uri, String localName, String qName)
		throws XmlParseException 
	{
		// no-op
	}
	
	@Override
	public void dump(PrintWriter pw, int indent) 
	{
		super.dump(pw, indent);
		String tab = String.format("%" + (indent + 2) + "s", "");
		
		pw.println(tab + m_className + " (" + m_start + " .. " + m_end + ")");
	}
}
